<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>propclass/trigger.h Source File (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">propclass/trigger.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    Crystal Space Entity Layer</span>
<a name="l00003"></a>00003 <span class="comment">    Copyright (C) 2004 by Jorrit Tyberghein</span>
<a name="l00004"></a>00004 <span class="comment"></span>
<a name="l00005"></a>00005 <span class="comment">    This library is free software; you can redistribute it and/or</span>
<a name="l00006"></a>00006 <span class="comment">    modify it under the terms of the GNU Library General Public</span>
<a name="l00007"></a>00007 <span class="comment">    License as published by the Free Software Foundation; either</span>
<a name="l00008"></a>00008 <span class="comment">    version 2 of the License, or (at your option) any later version.</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">    This library is distributed in the hope that it will be useful,</span>
<a name="l00011"></a>00011 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00012"></a>00012 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00013"></a>00013 <span class="comment">    Library General Public License for more details.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">    You should have received a copy of the GNU Library General Public</span>
<a name="l00016"></a>00016 <span class="comment">    License along with this library; if not, write to the Free</span>
<a name="l00017"></a>00017 <span class="comment">    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.</span>
<a name="l00018"></a>00018 <span class="comment">*/</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __CEL_PF_TRIGGER__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __CEL_PF_TRIGGER__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/cstypes_8h.html">cstypes.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/vector3_8h.html">csgeom/vector3.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/box_8h.html">csgeom/box.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/scf_8h.html">csutil/scf.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/weakrefarr_8h.html">csutil/weakrefarr.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="keyword">struct </span><a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>;
<a name="l00030"></a>00030 <span class="keyword">struct </span><a class="code" href="structiPcTrigger.html" title="This is a trigger property class.">iPcTrigger</a>;
<a name="l00031"></a>00031 <span class="keyword">struct </span><a class="code" href="structiPcMesh.html" title="This is a property class holding the representation of a mesh.">iPcMesh</a>;
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">enum</span> TriggerType
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035   TRIGGER_NONE = 0,
<a name="l00036"></a>00036   TRIGGER_SPHERE,
<a name="l00037"></a>00037   TRIGGER_BOX,
<a name="l00038"></a>00038   TRIGGER_ABOVE,
<a name="l00039"></a>00039   TRIGGER_BEAM
<a name="l00040"></a>00040 };
<a name="l00041"></a>00041 
<a name="l00045"></a><a class="code" href="structiPcTriggerListener.html">00045</a> <span class="keyword">struct </span><a class="code" href="structiPcTriggerListener.html" title="Listen to trigger actions.">iPcTriggerListener</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00046"></a>00046 {
<a name="l00047"></a>00047   SCF_INTERFACE (<a class="code" href="structiPcTriggerListener.html" title="Listen to trigger actions.">iPcTriggerListener</a>, 0, 0, 1);
<a name="l00048"></a>00048 
<a name="l00052"></a>00052   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcTriggerListener.html#acfb096b8116651b2ecc14e2084d1cc69" title="An entity enters this trigger.">EntityEnters</a> (<a class="code" href="structiPcTrigger.html" title="This is a trigger property class.">iPcTrigger</a>* trigger, <a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>* entity) = 0;
<a name="l00053"></a>00053 
<a name="l00057"></a>00057   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcTriggerListener.html#a875611bbee139893d3c0f9bfa298d8a2" title="An entity leaves this trigger.">EntityLeaves</a> (<a class="code" href="structiPcTrigger.html" title="This is a trigger property class.">iPcTrigger</a>* trigger, <a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>* entity) = 0;
<a name="l00058"></a>00058 
<a name="l00062"></a>00062   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcTriggerListener.html#ab7202932b0572071b2a24c352373f600" title="This entity enters a trigger.">EnterTrigger</a> (<a class="code" href="structiPcTrigger.html" title="This is a trigger property class.">iPcTrigger</a>* trigger, <a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>* entity) = 0;
<a name="l00063"></a>00063 
<a name="l00067"></a>00067   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcTriggerListener.html#a66ca231906da50bd3dca4c2a163b418b" title="This entity leaves a trigger.">LeaveTrigger</a> (<a class="code" href="structiPcTrigger.html" title="This is a trigger property class.">iPcTrigger</a>* trigger, <a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>* entity) = 0;
<a name="l00068"></a>00068 };
<a name="l00069"></a>00069 
<a name="l00112"></a><a class="code" href="structiPcTrigger.html">00112</a> <span class="keyword">struct </span><a class="code" href="structiPcTrigger.html" title="This is a trigger property class.">iPcTrigger</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00113"></a>00113 {
<a name="l00114"></a>00114   SCF_INTERFACE (<a class="code" href="structiPcTrigger.html" title="This is a trigger property class.">iPcTrigger</a>, 0, 1, 1);
<a name="l00115"></a>00115 
<a name="l00120"></a>00120   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcTrigger.html#a4f70fa9b1204bf5c78d6a53a23c87361" title="Add a trigger listener.">AddTriggerListener</a> (<a class="code" href="structiPcTriggerListener.html" title="Listen to trigger actions.">iPcTriggerListener</a>* listener) = 0;
<a name="l00124"></a>00124   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcTrigger.html#a39e6b01129b753fa96f620e116508e12" title="Remove a trigger listener.">RemoveTriggerListener</a> (<a class="code" href="structiPcTriggerListener.html" title="Listen to trigger actions.">iPcTriggerListener</a>* listener) = 0;
<a name="l00125"></a>00125 
<a name="l00129"></a>00129   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcTrigger.html#ad1901fe0820f039d07c27cbf90135335" title="Setup a spherical area as trigger zone.">SetupTriggerSphere</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a>* sector,
<a name="l00130"></a>00130         <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; center, <span class="keywordtype">float</span> radius) = 0;
<a name="l00131"></a>00131 
<a name="l00136"></a>00136   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcTrigger.html#ad1901fe0820f039d07c27cbf90135335" title="Setup a spherical area as trigger zone.">SetupTriggerSphere</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a>* sector,
<a name="l00137"></a>00137         <span class="keyword">const</span> <span class="keywordtype">char</span>* center_name, <span class="keywordtype">float</span> radius) = 0;
<a name="l00138"></a>00138 
<a name="l00142"></a>00142   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcTrigger.html#a76b21a885847ce2afc4ba07386c99111" title="Setup a box trigger zone.">SetupTriggerBox</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a>* sector, <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsBox3.html">csBox3</a>&amp; box) = 0;
<a name="l00143"></a>00143 
<a name="l00147"></a>00147   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcTrigger.html#a42e94ff5734555b8237e371d9585ec81" title="Setup a beam trigger zone.">SetupTriggerBeam</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a>* sector, <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; start,
<a name="l00148"></a>00148         <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; end) = 0;
<a name="l00149"></a>00149 
<a name="l00154"></a>00154   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcTrigger.html#ac0d4e3a1e2a9e3715fd0c1b1721a5d7c" title="Setup a trigger to fire if this mesh ends up above another mesh.">SetupTriggerAboveMesh</a> (<a class="code" href="structiPcMesh.html" title="This is a property class holding the representation of a mesh.">iPcMesh</a>* mesh, <span class="keywordtype">float</span> maxdistance) = 0;
<a name="l00155"></a>00155 
<a name="l00163"></a>00163   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcTrigger.html#acebddd45942c6805f6af3795c7c4a04e" title="By default pctrigger will monitor all entities.">MonitorEntity</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* entityname) = 0;
<a name="l00164"></a>00164 
<a name="l00169"></a>00169   <span class="keyword">virtual</span> <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="structiPcTrigger.html#a9fd53da08ca23c7827609b3cd9a508d3" title="Return the entity name that we are currently monitoring or 0 if monitoring all entities.">GetMonitorEntity</a> () <span class="keyword">const</span> = 0;
<a name="l00170"></a>00170 
<a name="l00176"></a>00176   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcTrigger.html#ab106374cd9edf9bc0252c4bd349f021c" title="By default pctrigger will monitor all entities.">MonitorClass</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* classname) = 0;
<a name="l00177"></a>00177 
<a name="l00182"></a>00182   <span class="keyword">virtual</span> <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="code" href="structiPcTrigger.html#ac75e33775bb8a61530054ac0e0cc26ff" title="Return the class name that we are currently monitoring or 0 if monitoring all entities.">GetMonitorClass</a> () <span class="keyword">const</span> = 0;
<a name="l00183"></a>00183 
<a name="l00191"></a>00191   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcTrigger.html#ac2b7070f0f9432a49f53b5b91b8132ab" title="Set the number of milliseconds we delay before monitoring all entities again.">SetMonitorDelay</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> delay, <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> jitter) = 0;
<a name="l00192"></a>00192 
<a name="l00198"></a>00198   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcTrigger.html#a280c3ccf877e9efabd2136694d37b05d" title="Enable monitoring on invisible entities.">EnableMonitorInvisible</a> (<span class="keywordtype">bool</span> en) = 0;
<a name="l00199"></a>00199 
<a name="l00206"></a>00206   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcTrigger.html#a42885ee0543f0407d51315dae06a517a" title="Enable/disable sending messages to the entity containing the trigger about other entities leaving of ...">EnableMessagesToSelf</a> (<span class="keywordtype">bool</span> en) = 0;
<a name="l00207"></a>00207 
<a name="l00214"></a>00214   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcTrigger.html#a2d4334fb6ed10595d46cbe486338e1ab" title="Enable/disable sending messages to the entities that enter or leave this trigger (messages like pctri...">EnableMessagesToOthers</a> (<span class="keywordtype">bool</span> en) = 0;
<a name="l00215"></a>00215 
<a name="l00219"></a>00219   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcTrigger.html#a95ed2e9e6c0dcb5f5f35e52bbe18693a" title="Enable/Disable trigger.">EnableTrigger</a> (<span class="keywordtype">bool</span> en) = 0;
<a name="l00220"></a>00220 
<a name="l00224"></a>00224   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiPcTrigger.html#a5b730c845446ac29be6c07942f601710" title="Return true if trigger is enabled.">IsEnabled</a> () <span class="keyword">const</span> = 0;
<a name="l00225"></a>00225 
<a name="l00230"></a>00230   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsWeakRefArray.html">csWeakRefArray&lt;iCelEntity&gt;</a>&amp; <a class="code" href="structiPcTrigger.html#ae271544b2adc7f4189605032358189cb" title="Get an array of all entities that are currently in the trigger area.">GetEntitiesInTrigger</a> () <span class="keyword">const</span> = 0;
<a name="l00231"></a>00231 
<a name="l00236"></a>00236   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiPcTrigger.html#a1f82e15788fa2aa5ce893c6418c37fe2" title="This only works if we are monitoring an individual entity.">Check</a> () = 0;
<a name="l00237"></a>00237 
<a name="l00239"></a>00239   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> <a class="code" href="structiPcTrigger.html#a902922920c0c8bad25affb56e50c8497" title="Get update delay for checking trigger.">GetUpdateDelay</a> () <span class="keyword">const</span> = 0;
<a name="l00241"></a>00241   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> <a class="code" href="structiPcTrigger.html#ac55dc58a9e74f414090fda644a78c59d" title="Get random jitter for update delay.">GetUpdateJitter</a> () <span class="keyword">const</span> = 0;
<a name="l00243"></a>00243   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiPcTrigger.html#ab9d51f8f05ad0000bfe17a6df81400cb" title="Get flag to control checking on invisible entities.">HasCheckingOnInvisibleEntities</a> () <span class="keyword">const</span> = 0;
<a name="l00245"></a>00245   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiPcTrigger.html#ac29a1467ed88c44d19252ea508dc6876" title="Get flag to let the trigger follow its own mesh.">HasFollowEntity</a> () <span class="keyword">const</span> = 0;
<a name="l00247"></a>00247   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcTrigger.html#a096868ae591d261cd9fd97d9bc6f06f0" title="Set flag to let the trigger follow its own mesh (default off).">SetFollowEntity</a> (<span class="keywordtype">bool</span> c) = 0;
<a name="l00249"></a>00249   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiPcTrigger.html#ac4f9969b574bff607618792ce8baeb0b" title="Get flag to let the trigger do strict checking for monitored entity.">HasStrictChecking</a> () <span class="keyword">const</span> = 0;
<a name="l00254"></a>00254   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcTrigger.html#a1c3043b5e682f11b3f8c3abcbee13e98" title="Set flag to let the trigger do strict checking for monitored entity.">SetStrictChecking</a> (<span class="keywordtype">bool</span> c) = 0;
<a name="l00256"></a>00256   <span class="keyword">virtual</span> TriggerType <a class="code" href="structiPcTrigger.html#adb7d7e25af17f329768d384f7d694b90" title="Get the type of this trigger.">GetTriggerType</a> () <span class="keyword">const</span> = 0;
<a name="l00257"></a>00257 };
<a name="l00258"></a>00258 
<a name="l00259"></a>00259 <span class="preprocessor">#endif // __CEL_PF_TRIGGER__</span>
<a name="l00260"></a>00260 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
